TRANSFORMATION PullP2SHRP

  -- Convert predicates built out of combinations of, p & p, p | p or ~ (p)
  -- such that p is of the form op OPLUS LANGLE f, g RANGLE, to the form
  --      (...((p OPLUS #2) OPLUS SHR) ... OPLUS SHR) if possible
  -- Success value is meaningless

 USES
  sft:        p OPLUS (f o g) --> p OPLUS f OPLUS g,
  pushneg:    ~ (p OPLUS f) --> ~ (p) OPLUS f,

  pulld1:     (p OPLUS f) | (q OPLUS f) --> (p | q) OPLUS f,
  pulld2:     (p OPLUS #2) | (q OPLUS SHR) --> ((p OPLUS #2 OPLUS #2) | q) OPLUS SHR,
  pulld3:     (p OPLUS SHR) | (q OPLUS #2) --> (p | (q OPLUS #2 OPLUS #2)) OPLUS SHR,
  pullc1:     (p OPLUS f) & (q OPLUS f) --> (p & q) OPLUS f,
  pullc2:     (p OPLUS #2) & (q OPLUS SHR) --> ((p OPLUS #2 OPLUS #2) & q) OPLUS SHR,
  pullc3:     (p OPLUS SHR) & (q OPLUS #2) --> (p & (q OPLUS #2 OPLUS #2)) OPLUS SHR,

  PullP2SHRF, CNF

 BEGIN
	-- Step 1:  First convert all subfunctions to PullP2SHRF
	BU {GIVEN _P OPLUS f DO PullP2SHRF (f)};

	-- Step 2:  Next, pull subfunctions into predicate
    TD {sft};

    -- Step 3:  Convert result into CNF and Push Negations Past oplus
    CNF;
    TD {pushneg};

    -- Step 4:  Link common disjunctions and then disjunctions
	REPEAT {BU {pulld1 || pulld2 || pulld3}};
	REPEAT {BU {pullc1 || pullc2 || pullc3}}

 END


 
