//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon Suk Lee (jl) 
//  FILE: DEPList.H
//  PROJ: COKO
//  DATE: 10/96                                                              
//
// SYNOPSIS
//  Classes for Dependancy List.
//  
//////////////////////////////////////////////////////////////////////////////


#ifndef _DEPLIST_H_
#define _DEPLIST_H_

#include <strings.h>
#include <stdlib.h>
#include <iostream.h>

class DEPNode
{
public:
  char * _value;
  DEPNode * _next;

  DEPNode(char * a);
  // Constructor

  ~DEPNode();
  // Destructor

};

class DEPList
{
private:
  DEPNode * _iterator;
  DEPNode * _head;

public:

  DEPList();
  // Constructor
  
  ~DEPList();
  // Destructor

  DEPNode * find(const char* a);
  // find a node with _value = a

  void insert(char* a);
  //  Insert a new node with _value = a to the list

  char* pop();
  // Pop off a front node from the list
  // Return a copy of _value

  int empty();
  // Is the list empty?

  void initIterator();
  // Initialize _iterator
  // This method is used with getValue method

  char* getValue();
  // Returns _value of the node that _iterator is pointing to.
  // After a call to this method, _iterator will point to the next node.
  // One can call this methods repeatly to get the _value of all the nodes.
  // However, initIterator has to be called before the initial call to this 
  // method.  

};

#endif

