//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon-Suk Lee (jl)
//  FILE: PCGivenStmt.H
//  PROJ: COKO
//  DATE: 6/11/96                                                              
//
// SYNOPSIS
// Class definitions for CGivenStmt.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCGIVENSTMT_H_
#define _PCGIVENSTMT_H_
#define MAXARG 20

#include <stdarg.h>
#include "PCStmt.H"
#include "PCPattern.H"
#include "PCEqn.H"

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CGivenStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. 
//  GivenStmt is consist of one or more equations.
//
//////////////////////////////////////////////////////////////////////////////

class CGivenStmt : public CStmt {
protected:
  CEqn* _eqnList[MAXARG];    
  // equation list

  CStmt *_stmt;
  // Given statement body

private:
  int _count;

public:
  CGivenStmt(CStmt* ... );                       
  // Constructor
  
  ~CGivenStmt();                      
  // Destructor
  
  CState *Exec(CState *);
  // What to do when executed

};

#endif
