//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl), Kee-Eung Kim (kek) 
//  FILE: PCIdent.H
//  PROJ: COKO
//  DATE: 5/5/97
//
// SYNOPSIS
//  Class definitions for CIdent.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCIDENT_H_
#define _PCIDENT_H_

#include <stdlib.h>
#include "KGlobals.H"
#include "KONonType.H"

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CIdent
//
// SYNOPSIS
//
//  This class actually wraps triple, (_Parent, _Child, _Which).
//  _Parent points to the parent of _Child, and _Which specifies
//  which child of the _parent.
//
//  Actually _Parent field is not used for now. It is always NULL.
//  Only _Child and _Which is used for coko compiler.
//  However, _Parent field is kept for possible future usage.
//
//////////////////////////////////////////////////////////////////////////////

class CIdent {
private:

  NonType *_Parent;                   
  // Pointer to the Parent.

  NonType *_Child;                
  // Pointer to the node which the identifier matches.

  int _Which;                        
  // Which child or the parent.

public:

  CIdent();                           
  // Parameterless Constructor

  CIdent(NonType *, int);             
  // Constructor with child and which

  CIdent(NonType *, NonType *, int);  
  // Constructor with parent, child and which

  ~CIdent();                          
  // Destructor

  NonType *Child();                   
  // Returns a copy of _Child

  NonType *Child_Look_Up();           
  // Returns a pointer to _Child

  int Which();                        
  // Returns _Which

};

#endif
