//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek)                                             
//  FILE: PCMulStmtCon.C
//  PROJ: COKO
//  DATE: 8/27/96                                                              
//
// SYNOPSIS
//  Method definitions for CMulStmtCon class.
//  
//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include "PCState.H"
#include "PCStmt.H"
#include "PCMulStmtCon.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CMulStmtCon
// Parameters:	(CStmt *first, CStmt *second)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CMulStmtCon::CMulStmtCon(CStmt *first, CStmt *second)
{
  _first = first;
  _second = second;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CMulStmtCon
// Parameters:	(void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CMulStmtCon::~CMulStmtCon(void)
{
  if(_first) { delete _first; _first = NULL; }
  if(_second) { delete _second; _second = NULL; }
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters:	(CState*)
//
// What to do when executed.
//         								    
//////////////////////////////////////////////////////////////////////////////

CState *CMulStmtCon::Exec(CState *s)
{

  if (_debug_)
	cout << "-- MulStmtCon Begins" << endl;

  // First, execute the former statements.
  s = _first->Exec(s);

  if (s->ISuccess() == T) { 
	// If the execution was successful, do the rest part
	s = _second->Exec(s);
	s->SetSuccess(T);
  }

  if (_debug_)
	cout << "-- MulStmtCon Ends" << endl;

  return s;
}

