//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon Suk  Lee (jl)                                             
//  FILE: PCPrintStmt.C
//  PROJ: COKO
//  DATE: 9/96                                                   
//
// SYNOPSIS
// 
//  This class is a derived class from CStmt. It is used for coko language 
//  debugging purposes.
//  
//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include "PCState.H"
#include "PCStmt.H"
#include "PCPrintStmt.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CPrintStmt
// Parameters: (int, char *)       
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CPrintStmt::CPrintStmt(int which_print, char *iname):
  _iname(NULL)
{
  _which_print = which_print;
  if (iname)
  	{
  	  _iname = new char[strlen(iname)+1];
  	  strcpy(_iname, iname);
  	}
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CPrintStmt
// Parameters: (void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CPrintStmt::~CPrintStmt(void)
{
  if (_iname) { delete [] _iname; _iname = NULL; }
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters: (CState*)
//
// What to do when executed.
//         								    
//////////////////////////////////////////////////////////////////////////////

CState *CPrintStmt::Exec(CState *s)
{
  if (_which_print == 1)
	{
	  CIdent * myNode;
	  if (_iname) 
		{ 
		  char * res = NULL;;
		  myNode = s->IFind(_iname);
		  cout << (res = (myNode->Child_Look_Up())->representation()) << endl;
		  if(res) { delete [] res; res = NULL; }		  
		}
	  else
		{
		  cout << "Warning @ PCPrintStmt : Exec" << endl;
		  cout << "Nothing to print out warning" << endl;
		}
	}
  else if (_which_print == 2)
	cout << _iname << endl;
  else if (_which_print == 3)
	{
	  char * res = NULL;
	  cout << (res = (s->Store())->representation()) << endl;
	  if (res) {delete [] res; res = NULL; }
	}

  s->SetSuccess(1);
  return s;
}
