//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl)
//  FILE: PCRepeatStmt.C
//  PROJ: COKO
//  DATE: 6/15/97
//
// SYNOPSIS
//  Method definitions for CRepeatStmt class.
//  
//////////////////////////////////////////////////////////////////////////////

#include "PCRepeatStmt.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CRepeatStmt
// Parameters: (CStmt *)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CRepeatStmt::CRepeatStmt(CStmt * stmt)
{
  _stmt = stmt;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CRepeatStmt
// Parameters:	(void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CRepeatStmt::~CRepeatStmt(void)
{
  if(_stmt) { delete _stmt; _stmt = NULL; }
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters:	(CState*)
//
// What to do when executed.
// Keep Executing _stmt until it fails
//         								    
//////////////////////////////////////////////////////////////////////////////

CState *CRepeatStmt::Exec(CState *s)
{
  if(_debug_)
	cout << "-- RepeatStmt Begins" << endl;

  s = _stmt->Exec(s);
  int success = s->ISuccess();

  while (s->ISuccess())
	{
	  s = _stmt->Exec(s);
	}

  s->SetSuccess(success);

  if(_debug_)
	cout << "-- RepeatStmt Ends" << endl;


  return s;
}
