//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl), Kee-Eung Kim (kek)   
//  FILE: PCRuleInvokeStmt.H
//  PROJ: COKO
//  DATE: 5/5/97                                                   
//
// SYNOPSIS
// Class definitions for CRuleInvokeStmt.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCRULEINVOKESTMT_H_
#define _PCRULEINVOKESTMT_H_

#include "PCStmt.H"
#include "PCRule.H"
#include "PCRuleBlock.H"

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CRuleInvokeStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. It is used for rule
//  invoke statements in COKO rule block.
//
//////////////////////////////////////////////////////////////////////////////

class CRuleInvokeStmt : public CStmt {
protected:
  CRule *_first_r;         // It could be rule or rule block we are 
  CRuleBlock *_first_rb;   // invoking on.
  char * _second;          // The identifier name we are going to invoke with
public:
  CRuleInvokeStmt(CRule*, char *);       // Constructor for rule invoke
  CRuleInvokeStmt(CRuleBlock*, char *);  // Constructor for rule block invoke
  virtual ~CRuleInvokeStmt();            // Destructor
  CState *Exec(CState *);                // What to do when executed
};

#endif
