//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl)
//  FILE: PCTopDownStmt.C
//  PROJ: COKO
//  DATE: 6/15/97
//
// SYNOPSIS
//  Method definitions for CTopDownStmt class.
//  
//////////////////////////////////////////////////////////////////////////////

#include "PCTopDownStmt.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CTopDownStmt
// Parameters: (CStmt *)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CTopDownStmt::CTopDownStmt(CStmt * stmt)
{
  _stmt = stmt;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CTopDownStmt
// Parameters:	(void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CTopDownStmt::~CTopDownStmt(void)
{
  if(_stmt) { delete _stmt; _stmt = NULL; }
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters:	(CState*)
//
// What to do when executed.
// Execute _stmt on Every node of the tree (current tree.)
//         								    
//////////////////////////////////////////////////////////////////////////////

CState *CTopDownStmt::Exec(CState *s)
{
  NonType * root = NULL;
  NonType * curr_child = NULL;
  int curr_which = 1;
  int success = 0;

  s = _stmt->Exec(s);

  success = s->ISuccess() || success;

  root = s->Store()->Copy_kTree();
  root->initCurrChild();
  curr_child = root->nextChild();
  while (curr_child)
	{
	  curr_child = curr_child->Copy_kTree();
	  s->SetStore(curr_child);
	  Exec(s); // recursion

	  success = s->ISuccess() || success;

	  NonType* result_child = s->Store()->Copy_kTree();

	  root->replaceChild(result_child, curr_which);
	  curr_child = root->nextChild();
	  curr_which++;
	}
  s->SetStore(root); // Restore old root

  // set success value.
  s->SetSuccess(success);

  return s;
}


