#ifndef _PAPARSER_H_
#define _PAPARSER_H_

#include <fstream.h>
//EDDIE_SUMMER_00(commented out)
//#include <libc.h>
#include "mstring.h"
#include <list.h>
#include <map.h>
#include <deque.h>
#include <stack.h>
#include <set.h>
#include <pair.h>

typedef enum {RMORE_LEFT, RMORE_RIGHT, REQUAL, RUNKNOWN} PARuleType;
typedef enum {FUNC, PRED, OBJ, BOOL, INDX} PAIdentType;
typedef list<string> PACode;
typedef set<string, less<string> > PAIdentSet;
typedef map<string, PARuleType, less<string> > PARuleTable;
typedef set<string, less<string> > DEPSet;
typedef pair<DEPSet, PAIdentType > PAPair;
typedef map<string, PAPair, less<string> > PAIdentTable;
typedef stack<PAIdentTable> PAStack;

typedef struct {PACode decl; PACode code; PACode pcode; } PAUseList;
typedef struct {string decl; string code; string pcode; } PAUse;
typedef struct {PACode code; } PABody;
typedef struct {string code; PARuleType type; string pcode;} PARule;
typedef struct {string code; string pcode; string pcode_w;} PAStmt;
typedef struct {PAIdentSet decl; string code; string pcode;} PAPattern;
typedef struct {string pcode;} PAInfer;

class PARuleBlock {
protected:
  string _name;
  PACode _includeCode;
  PACode _bodyCode;
  PACode _prologCode;
public:
  PARuleBlock(string name, PACode include, PACode body, PACode pcode);
  const char *Name(void);
  void Emit(ofstream&, ofstream&, ofstream&, ofstream&, ofstream&, ofstream&, int);
};

#endif
