//////////////////////////////////////////////////////////////////
//
//  NAME: Kee-Eung Kim (kek), Joon S. Lee (jl)
//  
//  FILE: PCChildPattern.H
//  PROJ: COKO
//  DATE: 5/5/97
// 
//  SYNOPSIS
//   Class definition for CChildPattern
//
/////////////////////////////////////////////////////////////////

#ifndef _PCCHILDPATTERN_H_
#define _PCCHILDPATTERN_H_

// By default, we assume that a KOLA node can have maximum of 10 children.
// If this is not true with future versions, just increase it!
#define MAX_CHILDREN 10

#include "PCPattern.H"

class CChildPattern : public CPattern
{
public:
  CChildPattern(NonType *);        
  // Constructor

  CState * initChildMatch(CState *); 
  // initializing curr_which
  // Call it before match. 

  CState * nextChildMatch(CState *);
  // Get next matching child

  CState * build(CState *);          
  // Overloaded build function

  CState * buildFromHere(CState* s, CIEnvStackDataType* a)
  { return build(s); }

  CState * buildCurrent(CState* s) 
  { return build(s); }

private:
  int curr_which;                
  // Which child we are currently referencing?

};

#endif
