//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek)                                             
//  FILE: PCMulStmtDis.H
//  PROJ: COKO
//  DATE: 8/27/96                                                              
//
// SYNOPSIS
//  Class definition for CMulStmtDis class.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCMULSTMTDIS_H_
#define _PCMULSTMTDIS_H_

#include <PCStmt.H>

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CMulStmtDis
//
// SYNOPSIS
//  This class is a derived class from CStmt. It is used for multiple 
//  statements connected by disjunction in COKO rule block.
//
//////////////////////////////////////////////////////////////////////////////

class CMulStmtDis : public CStmt
{
protected:
  CStmt *_first;                  // Former statement(s)
  CStmt *_second;                 // Later statement
public:
  CMulStmtDis(CStmt *, CStmt *);  // Constructor
  ~CMulStmtDis(void);             // Destructor
  CState *Exec(CState *);         // What to do when executed
};

#endif
