/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//
// NAME: Joon S. Lee (jl@cs.brown.edu)
// FILE: TYTChar.C
// PROJ: KOLA, COKO
// DATE: 9/97
//
//////////////////////////////////////////////////////////////////////////////

#include "TYTChar.H"
//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  TChar
// Parameters:	()							  
//
//  Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

TChar::TChar ()
{
    myname = TYPE_CHAR;
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  TChar
// Parameters:	(TChar &other)							  
//
//  Copy Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

TChar::TChar (TChar& other)
{
    myname = TYPE_CHAR;
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  ~TChar
// Parameters:	()							  
//
//  Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

TChar::~TChar ()
{
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  representation
// Parameters:	()							  
//
//  return "CHAR"
//         								    
//////////////////////////////////////////////////////////////////////////////

char* TChar::representation ()
{

    char *res = new char [strlen ("CHAR") + 1];
    sprintf (res, "%s", "CHAR");
    return res;

}



//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  prolog
// Parameters:	()							  
//
//  return "char"
//         								    
//////////////////////////////////////////////////////////////////////////////

char* TChar::prolog ()
{

    char *res = new char [strlen ("tchar") + 1];
    sprintf (res, "tchar");
    return res;

}

#ifdef _PROLOG_
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  sp_prolog
// Parameters:	()
//
// Since C/C++ functions only have indirect access to Prolog terms 
// via SP_term_refs, we need to convert kola tree to SP_term_refs.
// Converted kola tree will get passed to prolog runtime system.
//
// See the Sicstus prolog version 3#6 manual for more detailed info on
// the usage of SP_term_refs and other prolog supplied methods.
//
//////////////////////////////////////////////////////////////////////////////

SP_term_ref TChar::sp_prolog ()
{
  SP_term_ref res = SP_new_term_ref();
  SP_put_string(res,"tchar");
  return res;
}
#endif // _PROLOG_

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  Copy
// Parameters:	()							  
//
//  return copy of this as TObj*
//         								    
//////////////////////////////////////////////////////////////////////////////

TObj* TChar::Copy ()
{

    return new TChar (*this);

}


